import { firestore } from 'firebase/app';
declare type WithId<T> = T & {
    id: string;
};
export declare class BaseCrud<T extends Record<string, unknown>> {
    collectionReference?: firestore.CollectionReference<T>;
    documentReference?: firestore.DocumentReference<T>;
    private mergeIdToSnap;
    /**
     * @return {Promise<string>} id
     */
    create(data: T & {
        id?: string;
    }): Promise<string>;
    find(): Promise<WithId<T> | undefined>;
    all(arg?: {
        limit: number;
    }): Promise<WithId<T>[]>;
    update(data: Partial<T>): Promise<void>;
    destroy(): Promise<void>;
}
export {};
